{{- if .Values.grpcIngress.enabled -}}
{{- $fullName := include "default-chart.fullname" . -}}
{{- $grpcFullName := printf "%s-grpc" $fullName -}}
{{- $svcPort := .Values.grpcService.port -}}
{{- if and .Values.grpcIngress.className (not (semverCompare ">=1.18-0" .Capabilities.KubeVersion.GitVersion)) }}
  {{- if not (hasKey .Values.grpcIngress.annotations "kubernetes.io/ingress.class") }}
  {{- $_ := set .Values.grpcIngress.annotations "kubernetes.io/ingress.class" .Values.grpcIngress.className}}
  {{- end }}
{{- end }}
{{- if semverCompare ">=1.19-0" .Capabilities.KubeVersion.GitVersion -}}
apiVersion: networking.k8s.io/v1
{{- else if semverCompare ">=1.14-0" .Capabilities.KubeVersion.GitVersion -}}
apiVersion: networking.k8s.io/v1beta1
{{- else -}}
apiVersion: extensions/v1beta1
{{- end }}
kind: Ingress
metadata:
  name: {{ $grpcFullName }}
  labels:
    {{- include "default-chart.labels" . | nindent 4 }}
  {{- with .Values.grpcIngress.annotations }}
  annotations:
    {{- toYaml . | nindent 4 }}
  {{- end }}
spec:
  {{- if and .Values.grpcIngress.className (semverCompare ">=1.18-0" .Capabilities.KubeVersion.GitVersion) }}
  ingressClassName: {{ .Values.grpcIngress.className }}
  {{- end }}
  {{- if .Values.grpcIngress.tls }}
  tls:
    - hosts:
        - {{ .Values.grpcIngress.host | quote }}
  {{- end }}
  rules:
    {{- with .Values.grpcIngress }}
    - host: {{ .host | quote }}
      http:
        paths:
          {{- range .paths }}
          - path: {{ .path }}
            {{- if and .pathType (semverCompare ">=1.18-0" $.Capabilities.KubeVersion.GitVersion) }}
            pathType: {{ .pathType }}
            {{- end }}
            backend:
              {{- if semverCompare ">=1.19-0" $.Capabilities.KubeVersion.GitVersion }}
              service:
                name: {{ $fullName }}
                port:
                  number: {{ $svcPort }}
              {{- else }}
              serviceName: {{ $fullName }}
              servicePort: {{ $svcPort }}
              {{- end }}
          {{- end }}
    {{- end }}
{{- end }}
